<?php

if (!class_exists("wpdreamsCategories")) {

    /**

     * Class wpdreamsCategories

     *

     * Creates a cetegory selector UI element. Each category is stored separated by the "|" element.

     *

     * @author Ernest Marcinko <ernest.marcinko@wp-dreams.com>

     * @link http://wp-dreams.com, http://codecanyon.net/user/anago/portfolio

     * @copyright Copyright (c) 2014, Ernest Marcinko

     */

    class wpdreamsCategories extends wpdreamsType {

        function getType() {

            parent::getType();

            global $wpdb;

            $this->processData();

            $args = array();

            if ($this->selected != "")

                $args = array('exclude' => implode(",", $this->selected));

            $this->types = get_categories($args);

            echo "

      <div class='wpdreamsCategories'>

        <fieldset>

          <legend>" . $this->label . "</legend>";

            echo '<div class="sortablecontainer">Available categories<ul id="sortable' . self::$_instancenumber . '" class="connectedSortable">';

            if ($this->types != null && is_array($this->types)) {

                foreach ($this->types as $k => $v) {

                    if ($this->selected == null || !in_array($v->term_id, $this->selected)) {

                        echo '<li class="ui-state-default" bid="' . $v->term_id . '">' . $v->name . '</li>';

                    }

                }

            }

            echo "</ul></div>";

            echo '<div class="sortablecontainer">Drag here the categories you want to exclude!<ul id="sortable_conn' . self::$_instancenumber . '" class="connectedSortable">';

            if ($this->selected != null && is_array($this->selected)) {

                $args = "";

                if ($this->selected != "")

                    $args = array('include' => implode(",", $this->selected));

                $_cats = get_categories($args);

                foreach ($_cats as $k => $v) {

                    echo '<li class="ui-state-default" bid="' . $v->term_id . '">' . $v->name . '</li>';

                }

            }

            echo "</ul></div>";

            echo "

         <input isparam=1 type='hidden' value='" . $this->data . "' name='" . $this->name . "'>";

            echo "

         <input type='hidden' value='wpdreamsCategories' name='classname-" . $this->name . "'>";

            ?>

            <script>

                (function ($) {

                    $(document).ready(function () {

                        $("#sortable<?php echo self::$_instancenumber ?>, #sortable_conn<?php echo self::$_instancenumber ?>").sortable({

                            connectWith: ".connectedSortable"

                        }, {

                            update: function (event, ui) {

                                parent = $(ui.item).parent();

                                while (!parent.hasClass('wpdreamsCategories')) {

                                    parent = $(parent).parent();

                                }

                                var items = $('ul[id*=sortable_conn] li', parent);

                                var hidden = $('input[name=<?php echo $this->name; ?>]', parent);

                                var val = "";

                                items.each(function () {

                                    val += "|" + $(this).attr('bid');

                                });

                                val = val.substring(1);

                                hidden.val(val);

                            }

                        }).disableSelection();

                    });

                }(jQuery));

            </script>

            <?php

            echo "

        </fieldset>

      </div>";

        }



        function processData() {

            $this->data = str_replace("\n", "", $this->data);

            if ($this->data != "")

                $this->selected = explode("|", $this->data);

            else

                $this->selected = null;

            //$this->css = "border-radius:".$this->topleft."px ".$this->topright."px ".$this->bottomright."px ".$this->bottomleft."px;";

        }



        final function getData() {

            return $this->data;

        }



        final function getSelected() {

            return $this->selected;

        }

    }

}

?>